#################################################################################
# Licensed Materials - Property of IBM and/or HCL
# (c) Copyright IBM Corp. 2005-2017 All Rights Reserved.
# (c) Copyright HCL Technologies Ltd. 2017.  All Rights Reserved.
#
# Note to U.S. Government Users Restricted Rights:
# Use, duplication or disclosure restricted by GSA ADP Schedule
# Contract with IBM Corp.
#################################################################################
use FileHandle ;

STDOUT->autoflush(1);
STDERR->autoflush(1);

$main::SCRIPTDIR="$ENV{'TESTRTDIR'}/lib/scripts/";
require $SCRIPTDIR ."Fcts.pl";
require $SCRIPTDIR ."Tools.pl";

$TARGETDIR=$ENV{ATLTGT};
my $out_file='';
my $FILENAME;
my $language='CPP';
my $CPPFLAGS;
my @COMPLETE_INCLUDE_DIR_LIST;
my @GENERATION_CONDITION;
#
# perllauncher PreproSourceC <source> -I<path> -D<def> [-o <result>] [flags] [-FEOPT list=prepro.txt]
#
#
while(@ARGV) {
    $_=shift(@ARGV);
	if(/^\"?-I(.+)$/){
		my $p=$1;$p=~s/\"//g;
		push(@COMPLETE_INCLUDE_DIR_LIST,$p);
	} elsif(/^\"?-D(.+)$/){
		my $p=$1;$p=~s/\"$// if(s/^\"//);
		push(@GENERATION_CONDITION,$p);
	} elsif(/^-o$/){
		$out_file=shift(@ARGV);
		$out_file=~s/\"//g;
	} elsif(/^-v/){
		$ENV{'ATTOLSTUDIO_VERBOSE'}=1;
	} elsif(/^-/){
		$CPPFLAGS.=' '.$_;
	} else {
		if($FILENAME eq ''){
			$FILENAME=$_ ;
			$FILENAME=~s/"//g;
		} else {
			$CPPFLAGS.=' '.$_;
		}
	}
}
my ($srcdir, $srcname, $srcext) = SplitFileName( $FILENAME );
$out_file=$srcname.'.i' if($out_file eq '');
$language=LanguageOf($srcext,$language);
$status=atl_cppInternal ($language, $FILENAME, $out_file, $CPPFLAGS,
			   \@GENERATION_CONDITION, \@COMPLETE_INCLUDE_DIR_LIST );

exit($status);
1;

