#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2003-2016 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################

##########################################################################
#                                                                        # #
# Rational Test RealTime                                                 #   #
#                                                                        #######
#                        -*-  System Testing report -*-                        #
#                                                                              #
#                                                                              #
################################################################################
#$Id: SystemTestReport.pl,v 1.1.2.1.2.4 2009/07/03 08:49:21 rfrance Exp $
################################################################################

#$ATSXRDSIZEMAX=10000000;
$ATSXRDSIZEMAX= 25000000 unless($ATSXRDSIZEMAX);

################################################################################
# SystemTest atsmerge  
################################################################################
sub atsmerge #(\@\@)
{
my ($tdcs,$rios)=@_;

	my $FileList;
	my $res;
	my $ret=0;
	my $matp=$ATPMODE;$ATPMODE=0;
	my $matq=$ATQMODE;$ATQMODE=0;
	my $matc=$ATCMODE;$ATCMODE=0;
	my $matt=$ATTMODE;$ATTMODE=0;
	my $mata=$ATAMODE;$ATAMODE=0;
	my $matz=$ATZMODE;$ATZMODE=0;
	my $matg=$ATGMODE;$ATGMODE=0;
	my $matd=$DCPMODE;$DCPMODE=0;
	foreach $elem (@$tdcs)
	{
	    if($elem ne '')
	    {
	    	if(-r $elem)
	    	{
		    	$res|=1;
			$FileList.="\"$elem\" ";
		}
	    }
	}
	foreach $elem (@$rios)
	{
	    if($elem ne '')
	    {
	    	if(-r $elem)
	    	{
		    	$res|=2;
			$FileList.="\"$elem\" ";
			ParseAtsRioFile($elem);
		}
	    }
	}
	if($res == 3)
	{
		my $Options="";
		$Options.="-RA=$ATS_RA" if ($ATS_RA && ($ATS_RA ne "NONE"));
		$Options.=" -VA=$ATS_VAL_DISP" if ($ATS_VAL_DISP && ($ATS_VAL_DISP ne "NONE"));
		
		my $headFile="$NAME.summary.txt";
		if(open (HDR,">$headFile")){
		     if($RTRT_ACTIVATED){ #=1 on eclipse
			print HDR "Project=$PROJECT_NAME\n";
			print HDR "Project configuration=$CONFIGURATION\n";
			print HDR "Workspace=$WORKSPACE_PATH\n";
			print HDR "Test name=$NAME\n";
			print HDR "Report file=$NAME.xrd\n";
			print HDR "\$PREPROCESS\n";
			print HDR "\$HEADERLINE\n";
		     }else{
			print HDR "Project=$PROJECT_NAME\n";
			print HDR "Project file=$PROJECT_PATH.rtp\n";
			print HDR "Project configuration=$CONFIGURATION\n";
			print HDR "Workspace=$WORKSPACE_NAME\n";
			print HDR "Test node=$NAME\n";
			print HDR "Report file=".absolutePath("$NAME.xrd")."\n";
			print HDR "\$PREPROCESS\n";
			print HDR "\$HEADERLINE\n";
		     }
		     close HDR;
		}

		if($Ini{'REPORTHEADER'}) {
		     print "REPORTHEADER specified as:$LP_TARGETDIR/cmd/$Ini{'REPORTHEADER'}\n";
		     print "sub reportHeader($headFile,$RTRT_ACTIVATED)\n";
		     require "$TARGETDIR/cmd/$Ini{'REPORTHEADER'}";
		     reportHeader($headFile,$RTRT_ACTIVATED);
		}

		print &PerlTranslate("SystemTestReport.pl", "\nPostprocessing results...\n");
		print "*****************************************************\n"; # NO TRANSLATION
		my $status=SystemP($BINPATH."atsmerge $FileList $Options -RDD=\"$NAME.rdd\"");
		if ($status>3)
		{
			print &PerlTranslate("SystemTestReport.pl", "Failed.\n");
			$ret=1;
			#return 1;
		}
		else
		{
			open ( LOG, ">$LOGFILENAME" ) or die &PerlTranslate("SystemTestReport.pl", "Cannot open log file.\n");
			print  LOG "XRD $NAME.xrd\n";
			print  LOG "TSF $NAME.tsf\n";
			print  LOG "TDF $NAME.tdf\n";
			print  LOG "DUM $NAME.hdr\n";
			foreach $elem (@$rios)
			{
			    if($elem ne '')
			    {
				print  LOG "DUM $elem\n";
				print  LOG "DUM $elem.bak\n";
				$elem=~s/\.rio$//;
				print  LOG "DUM $elem.rod\n";
				print  LOG "DUM $elem.ro\n";
			    }
			}
			if(-s "$NAME.xrd" > $ATSXRDSIZEMAX)
			{
				foreach(SplitSystemTestXrd("$NAME.xrd")){
					print  LOG "DUM $_\n";
				}
			}
			close( LOG );
		}
	}
	else
	{
	   my $filetype="rio and tdc";
	   $filetype="rio" if($res == 1);
	   $filetype="tdc" if($res == 2);
		print &PerlTranslate("SystemTestReport.pl", "$filetype files does not exist\nexpecting:%1 and %2\n","",join(',',@$tdcs),join(',',@$rios));
		$ret=1;
	}
	$ATPMODE=$matp;
	$ATQMODE=$matq;
	$ATCMODE=$matc;
	$ATTMODE=$matt;
	$ATAMODE=$mata;
	$ATZMODE=$matz;
	$ATGMODE=$matg;
	$DCPMODE=$matd;
return $ret;
}

################################################################################
# SplitSystemTestXrdProc
# export all CALL and PROC blocks to additional files and generate link 
# into input file in place of blocks
# Arguments:
#   $xrd : xrd file to split
# return list of generated files
################################################################################
sub SplitSystemTestXrdProc #($)
{
  my $xrd=shift;
  my @files;
  my $xrdout;
  my $filenum=0;
  my $size;
  my $filter=0;
  my $tag;
  my $tagv;
  my $ttl;
  my $name;
  my $state=100;
  my $section=0;
  my $node=0;
  my $nodePart=0;
  my $fileHeader;
  my $fileFooter=0;
  my $sectionTag='ss';
  my $sectionName='Instance';
  my $CatchType='_Proc';
  rename($xrd,"$xrd.bak");
  if(open (ORG, "$xrd.bak" )) {
  	print &PerlTranslate("SystemTestReport.pl", "Splitting XRD file: move Proc & Call\n");
  	my ($dir,$base,$e)=SplitFileName($xrd);
  	open ( SUM, ">$xrd") or die &PerlTranslate("SystemTestReport.pl", "Cannot open summary xrd file.\n");
  	while(<ORG>) {
		#memo xrd header (first section)
		$fileHeader.=$_ if($state==100);
		#count deth level
		if(/<XROD:NODE /) {$node++;}
		if(/<SECTION/) {$section++; if(/TAG=.(\w+)/){$sectionTag=$1;} if(/\<TEXT\>([^\<]+)\</){$sectionName=$1;}}
				
		#filter XROD:NODE type="Procedure" or type="Call" and add a link to splitted xrd for detail
		if($state==0 && /type=.(Call|Procedure)/ && /state=.ok/&& /name=.((PROC|CALL) \w+)/){$name=$1;$state=44;}
		if($state==44 && /<TITLE LEVEL=.(\d+)/){$ttl=$1;$state=45;}
		if($state==45 && /TAG=.(\w+).\s/){$tag=$1;$tagv=$tag;$tagv=~s/inst\d+line//;
			
			$state=46; 
			$filter=1;
			$nodePart=$node;
			#print "P$node"; 
			print SUM "<TITLE LEVEL=\"$ttl\" STYLE=\"Link\"><LINK TARGET=\"xrdlink://$base$CatchType$filenum.xrd#$tag\"><TEXT>$name ($tagv)</TEXT>\n</LINK>\n</TITLE>\n";
			s,<\/TEXT>, ($tagv)<\/TEXT>,;
		}
		if($filter){
		    	if($xrdout eq ''){
				$size=0;
				$xrdout=$base.$CatchType.$filenum.'.xrd';
				open ( OU, ">$dir$xrdout") or die &PerlTranslate("SystemTestReport.pl", "Cannot open splitted xrd file.\n");
				push(@files,$dir.$xrdout);
				print OU $fileHeader,"<SECTION TAG=\"$sectionTag\"><TITLE LEVEL=\"0\" STYLE=\"Link\"><LINK TARGET=\"xrdlink://$base.xrd#$sectionTag\"><TEXT>$sectionName</TEXT></LINK></TITLE>\n";
		    	}
		    
			print OU ;
			$size+=length($_);
		} else {
			print SUM ;
		}
		
		#filter block content for Master xrd until </XROD:NODE>
		if(/<\/XROD:NODE>/) {
			$node--; #print $node;
			if($filter && $node<$nodePart){
				$filter=0;
				$state=0;
				if($size >= $ATSXRDSIZEMAX){
					print OU "</SECTION>\n";
					print OU "</XROD:NODE>\n" if($fileFooter);
					print OU "</DOCUMENT>\n</APIDOC>\n</XROD>\n";
					close OU ;
					$xrdout='';
					$filenum++;
				}
			}
			$node=0 if($node<0);
		}
		if(/<\/SECTION>/) {
			$section--;
			$sectionTag.='2'; #in case we dont see others
			$sectionName.='2';
			$fileFooter=$node if($state==100);
			$state=0;
			if($xrdout ne ''){
				print OU "</SECTION>\n" unless($filter);
				print OU "</XROD:NODE>\n" if($fileFooter);
				print OU "</DOCUMENT>\n</APIDOC>\n</XROD>\n";
				close OU ;
				$filter=0;
				$xrdout='';
				$filenum++;
			}
		}
  	}
	close ORG;
	close SUM;
	if($xrdout ne ''){
		print OU "</SECTION>\n</DOCUMENT>\n</APIDOC>\n</XROD>\n";
	}
	close OU;
  }
  unlink("$xrd.bak") unless($filenum);
  return @files;
}

################################################################################
# SplitSystemTestXrd
# export all CALL & PROC blocks and Send,Waited,Received Events to additional files
# and generate link into input file in place of blocks
# Arguments:
#   $xrd : xrd file to split
# return list of generated files
################################################################################
sub SplitSystemTestXrd #($)
{
  my $xrd=shift;
  my @files=SplitSystemTestXrdProc($xrd);
  my $filter_send=1;
  my $filter_Waited=1;
  my $xrdout;
  my $filenum=0;
  my $size;
  my $filter=0;
  my $tag;
  my $tagv;
  my $ttl;
  my $name;
  my $WaittilState=0;
  my $state=100;
  my $section=0;
  my $node=0;
  my $nodePart=0;
  my $fileHeader;
  my $fileFooter=0;
  my $sectionTag='ss';
  my $sectionName='Instance';
  my $CatchType='_events';
  if((-s $xrd) >$ATSXRDSIZEMAX  && open (ORG, "$xrd" )) {
  	print &PerlTranslate("SystemTestReport.pl", "Splitting XRD file: move Events.\n");
  	my ($dir,$base,$e)=SplitFileName($xrd);
  	open ( SUM, ">$xrd.tmp") or die &PerlTranslate("SystemTestReport.pl", "Cannot open summary xrd file.\n");
  	while(<ORG>) {
		#memo xrd header (first section)
		$fileHeader.=$_ if($state==100);
		#count deth level
		if(/<XROD:NODE /) {$node++;}
		if(/<SECTION/) {$section++; if(/TAG=.(\w+)/){$sectionTag=$1;} if(/\<TEXT\>([^\<]+)\</){$sectionName=$1;}}
				
		#filter XROD:NODE type="Waittil" and add a link to splitted xrd for detail
		if($state==0 && /type=.Waittil/ && /state=.(..)/){$WaittilState=0;$WaittilState=1 if($1 eq 'ok');}

		if($state==0 && /type=.Send Events/ && $filter_send && /state=.ok/ && /name=.(SEND [^\"]+)\"/){$name=$1;$state=14;}
		
		if($state==0 && $WaittilState==1 && /type=.(Waited Events)/ && $filter_Waited){$name=$1;$state=14;}
		if($state==0 && $WaittilState==1 && /type=.(Received Events)/){$name=$1;$state=14;}
		if($state==14 && /<TITLE LEVEL=.(\d+)/){$ttl=$1;$state=15;}
		if($state==15 && /TAG=.(\w+).\s/){$tag=$1;$tagv=$tag;$tagv=~s/inst\d+line//;
			$state=16; 
			$filter=1;
			$nodePart=$node;
			#print "P$node"; 
			print SUM "<TITLE LEVEL=\"$ttl\" STYLE=\"Link\"><LINK TARGET=\"xrdlink://$base$CatchType$filenum.xrd#$tag\"><TEXT>$name ($tagv)</TEXT>\n</LINK>\n</TITLE>\n";
			s,<\/TEXT>, ($tagv)<\/TEXT>,;
		}
		
		if($filter){
		    	if($xrdout eq ''){
				$size=0;
				$xrdout=$base.$CatchType.$filenum.'.xrd';
				open ( OU, ">$dir$xrdout") or die &PerlTranslate("SystemTestReport.pl", "Cannot open splitted xrd file.\n");
				push(@files,$dir.$xrdout);
				print OU $fileHeader,"<SECTION TAG=\"$sectionTag\"><TITLE LEVEL=\"0\" STYLE=\"Link\"><LINK TARGET=\"xrdlink://$base.xrd#$sectionTag\"><TEXT>$sectionName</TEXT></LINK></TITLE>\n";
		    	}
		    
			print OU ;
			$size+=length($_);
		} else {
			print SUM ;
		}
		
		#filter block content for Master xrd until </XROD:NODE>
		if(/<\/XROD:NODE>/) {
			$node--; #print $node;
			if($filter && $node<$nodePart){
				$filter=0;
				$state=0;
				if($size >= $ATSXRDSIZEMAX){
					print OU "</SECTION>\n";
					print OU "</XROD:NODE>\n" if($fileFooter);
					print OU "</DOCUMENT>\n</APIDOC>\n</XROD>\n";
					close OU ;
					$xrdout='';
					$filenum++;
				}
			}
			$node=0 if($node<0);
		}
		if(/<\/SECTION>/) {
			$section--;
			$sectionTag.='2'; #in case we dont see others
			$sectionName.='2';
			$fileFooter=$node if($state==100);
			$state=0;
			if($xrdout ne ''){
				print OU "</SECTION>\n" unless($filter);
				print OU "</XROD:NODE>\n" if($fileFooter);
				print OU "</DOCUMENT>\n</APIDOC>\n</XROD>\n";
				close OU ;
				$filter=0;
				$xrdout='';
				$filenum++;
			}
		}
  	}
	close ORG;
	close SUM;
	if($xrdout ne ''){
		print OU "</SECTION>\n</DOCUMENT>\n</APIDOC>\n</XROD>\n";
	}
	close OU;
  	rename("$xrd.tmp",$xrd);
  }
  return @files;
}

1;
