#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2009 All Rights Reserved.
#  (c) Copyright HCL Technologies Ltd. 2017-2018.  All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################

##########################################################################
#                                                                        # #
# Rational Test RealTime                                                 #   #
#                                                                        #######
#                      -*-  Binaries version lister -*-                        #
#                                                                              #
#                                                                              #
################################################################################
#$Id: binList.pl,v 1.1.2.5 2010/04/06 09:51:14 rfrance Exp $
################################################################################

die "Environment variable TESTRTDIR not found. Exiting.\n\n" if(!defined($ENV{'TESTRTDIR'})); # NO TRANSLATION
$TESTRTDIR="$ENV{'TESTRTDIR'}";
$SCRIPTDIR="$TESTRTDIR/lib/scripts/";
require $SCRIPTDIR . "Fcts.pl";
use FileHandle;

STDOUT->autoflush(1);
STDERR->autoflush(1);

$LOGFILENAME="";
require $ARGV[0] if(($ARGV[0]=~m/\.pl$/) && (-f $ARGV[0])); #environment and global variables.
my @binList=(
"perllauncher -version",
"attolalk -version",
attolchop ,
attolpostproada ,
attolpreproADA ,
attolstartADA ,

attolstartC ,
attolpreproC ,
attolpostpro ,
#mdl2ptu,atm2stu,
rod2xrd ,
rod2req ,
Testoptimizer ,

atlsplit ,
"attloop -version",
"attolada -version",
"attolcc1 -version",
"attolccp -version",
"attolcc4 -version",
"attolcov -version",
attsplit ,
extrdumpieee ,
metada ,
"metcc1 -version",

"crccc -version",
"crcld -version",

attolpreproCPP ,
attolstartCPP ,

atopospro ,
atoprepro ,
atostart ,
atostart4 ,

"atsagtd 80 80 80 80",
"atsload -SEPARATOR=\"letters\" toBeRemoved.rod",
"atsmerge toBeRemoved",
"atspostpro toBeRemoved toBeRemoved",
"atspreproC toBeRemoved toBeRemoved toBeRemoved",
"atspreproCPP toBeRemoved toBeRemoved toBeRemoved",
"atsspv toBeRemoved.spv",
"atsuml -name toBeRemoved",


"adatags -version",
"ctags --version"
);

my $details=0;

sub executeBin
{
   my $cmd=shift;
   my $Ret;
   my $ver;
   my $vline;
   my $vStr;
   my $tempDir='/tmp/';
   	if($^O =~ /win32/i){
   		$tempDir=$ENV{TEMP}.'\\';
   	} else {
   		$cmd =~s/^atsagtd/atsagtd.bin/;
   	}
    	$Ret=system("$cmd >${tempDir}Out.txt 2>${tempDir}Err.txt");

	open(File,"<${tempDir}Out.txt"); while(<File>) { # BlaBlaBla Report Generator 7.5.0.0.276.008
		#if(/IBM\(R\) Rational\(R\) .* (\d\.\d\.\d\.\d(\.\d+\.\d+)?)/)
		if(/Rational\W.* (\d\.\d\.\d\.\d(\.\d+\.\d+)?)/)
		{
		   #print ;
		   $ver=$1;
		}
		elsif(/(\d\.\d\.\d\.\d(\.\d+\.\d+)?)/)
		{
		   $vStr=$1;
		   last if($2);
		}
		elsif(/\d\.\d/)
		{
		   $vline=$_;
		}
	} close(File);
	unless($ver) {
	    open(File,"<${tempDir}Err.txt"); while(<File>) {
		#if(/IBM\(R\) Rational\(R\) .* (\d\.\d\.\d\.\d(\.\d+\.\d+)?)/)
		if(/Rational\W.* (\d\.\d\.\d\.\d(\.\d+\.\d+)?)/)
		{
		   #print ;
		   $ver=$1;
		}
		elsif(/(\d\.\d\.\d\.\d(\.\d+\.\d+)?)/)
		{
		   $vStr=$1 unless($vStr);
		   last if($2);
		}
		elsif(/\d\.\d/)
		{
		   $vline=$_ unless($vline);
		}
	    } close(File);
	}
	unlink("${tempDir}Out.txt","${tempDir}Err.txt","toBeRemoved.lis");
	unless($ver)
	{
		$ver=$vStr;
		unless($ver)
		{
			$ver=$vline;

		}
	}
	return $ver;
}

sub main
{
my $ver;
my $attolBinDir=GetBinDir().'/';

    print "version.pl \t$TOOL_VERSION\n";
    print "TDP_runtime \t$VERSION\n";

  foreach my $bin (@binList){

    $ver=executeBin($bin);
    $bin=~s/^(\w+)\s.*/$1/;
    unless(-f "$attolBinDir$bin"){
    	$bin.=".exe" if(-f "$attolBinDir$bin.exe");
    }
    print "$bin \t$ver\n";
    if($details){
    	system("what \"$attolBinDir$bin\"");
    }
  }
return 0;
}

exit(main());
1;
