##!perl -w
#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2010-2011 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################
#This file is not anymore used since 8.0.1 but delivered for compatibility.
#TestRT_app.pl with $STAGE='e' is used instead
################################################################################

# useful for stdout/stderr direct viewing inside 'console' of studio window
# (better: we have stdout/stderr lines in right order and not stderr before stdout
use FileHandle ;
STDOUT->autoflush(1);
STDERR->autoflush(1);

die "Environment variable TESTRTDIR not found. Exiting.\n" if(!defined($ENV{'TESTRTDIR'})); # NO TRANSLATION
$main::SCRIPTDIR="$ENV{'TESTRTDIR'}/lib/scripts/";
require $SCRIPTDIR . "Fcts.pl";
require $SCRIPTDIR . "Tools.pl";
require $SCRIPTDIR . "Split.pl";

sub trtReadArgs
{

	## globals ############
	$main::TestRTCC=1;
	#######################
	$OUTDIR='.';
	$INIFILE='tp.ini';
	$STAGE ='l';
	$LOGFILENAME='trtld.log';
	require $SCRIPTDIR ."BatchCCDefaults.pl";
	$TARGETDIR=$ENV{ATLTGT};
	push(@argv,' ');
	#
	# trtex -config <envNnode.pl> -p <TESTPROGRAM> <ARGS>
	#
	#  INTDIR is set from -o option if not yet specified in the envNode.pl
	$_=shift(@ARGV);
	if(/^-config/){
		$nodeSettings=shift(@ARGV);
		$nodeSettings=~s/\"//g;
		die "$nodeSettings not found. Unable to Launch command.\n" unless (-f $nodeSettings);
		require $nodeSettings;
	} else {
	    print &PerlTranslate("trtex.pl", "trtex usage -config <envNode.pl> [-p <TESTPROGRAM>] [<ARGS>]\n", "usage");
	    exit(1);
	}
	if($ARGV[0] eq '-p'){
		shift(@ARGV);
		$TESTPROGRAM=shift(@ARGV);
	}
	$TESTPROGRAM=~s/\"//g;
	$ARGUMENTS=join(' ',@ARGV);
	@ARGV=($nodeSettings);# be compatible with studio

}


sub trtExec
{
my @Splitted=();

# Change Dir to the configuration folder
chdir($CONFIGURATION);

my $CurrentDir=GetCurrentDir();
$TESTPROGRAM=File::Spec->abs2rel( $TESTPROGRAM, $CurrentDir ) ;
$TESTPROGRAM='.'.PATH_SEPARATOR.$TESTPROGRAM  unless ( $TESTPROGRAM=~m/\\\// );
	print &PerlTranslate("trtex.pl", "Executing %1 %2...\n", "%1 is the program to be executed and %2 contains the arguments given to it", $TESTPROGRAM, $ARGUMENTS);
	print &PerlTranslate("trtex.pl", "from %1\n", "%1 is the current directory", $CurrentDir);
	my $status = AtlExec ($TESTPROGRAM, $ATL_OUT_FILE, $ARGUMENTS);
	EndStep($status);
        $status=0; #status is shown but not used

	$status=splitAfterExec();
	exit(1) if($status);

	#clean the logfile.
	cleanLogFile(@Splitted);
return 0;
}

################################################################################
# main
################################################################################
unless($main::TestRTCC){

  trtReadArgs();
  die "TDP not found.\n" unless(-f $TARGETDIR . "/cmd/atl_exec.pl");

  require $TARGETDIR . "/cmd/atl_func.pl";
  require $TARGETDIR . "/cmd/atl_exec.pl";
  EnterInScript();
  trtExec();
  exit(0);
}
1;

