##!perl -w
#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2003-2008 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################
##########################################################################
#                                                                        # #
# Rational Test RealTime                                                 #   #
#                                                                        #######
#                   -*-  registry for TDP generation -*-                       #
#                                                                              #
#                                                                              #
################################################################################

use Win32API::Registry qw(:ALL);
use Win32::TieRegistry;

sub atl_getRegKey
{
  my $val="";
  if ($^O eq "MSWin32") {
	my ($pathKey,$valKey) = split("::",shift);
	$pathKey=~s/\\\\/\\/g;
	my $Key = $Win32::TieRegistry::Registry->{$pathKey};
	if ($Key){
		$val = $Key->{$valKey};
	} elsif(!$pathKey=~m/Wow6432Node/ && $pathKey=~m/\\SOFTWARE\\/i){
	    my $valkeyW=$valkey;
		$valKeyW=~s/SOFTWARE\\/SOFTWARE\\Wow6432Node\\/;
		print "try using valkey=$valkeyW\n";
		$Key = $Win32::TieRegistry::Registry->{$pathKey};
		if ($Key){
			$val = $Key->{$valKeyW};
		}
	}
	unless($val) #try using 64bits Registers
	{
		my $key;
		my $nodeId;
		my $type;
		my $HKLMpath=$pathKey;
		$type=HKEY_LOCAL_MACHINE if($HKLMpath=~s/HKEY_LOCAL_MACHINE\\+//);
		$type=HKEY_CURRENT_USER  if($HKLMpath=~s/HKEY_CURRENT_USER\\+//);
		print "try using 64bits Registry\n";
		if($type && RegOpenKeyEx( $type, "$HKLMpath", 0, KEY_READ|0x0100, $key ) ) {
		  RegQueryValueEx($key, "$valKey", [], $type, $nodeId, []);
		  RegCloseKey( $key );
		  print  "using: RegOpenKeyEx ==>type=$type, nodeId=$nodeId\n";
		  $val=$nodeId;
		}
	}
  }
  return $val;
}

1;