

/*
 *  Licensed Materials - Property of IBM
 *  Restricted Material of IBM
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2011 All Rights Reserved.
 *  (c) Copyright HCL Technologies Ltd. 2017-2018.  All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


/*******************************************************************************
* $Descr: C/C++ Language Library Header $
*******************************************************************************/

/* Multiple inclusions guard: */
#ifndef TP_H_INCLUDED
#define TP_H_INCLUDED
#define RTRT_TDP_VERSION 8310

/* Avoid compilation warnings if undefined */
#ifndef USE_ATU
#define USE_ATU ATL_NO
#endif
#ifndef USE_ATV
#define USE_ATV ATL_NO
#endif
#ifndef USE_ATS
#define USE_ATS ATL_NO
#endif
#ifndef USE_ATO
#define USE_ATO ATL_NO
#endif
#ifndef USE_ATK
#define USE_ATK ATL_NO
#endif
#ifndef USE_ATC
#define USE_ATC ATL_NO
#endif
#ifndef USE_ATT
#define USE_ATT ATL_NO
#endif
#ifndef USE_ATP
#define USE_ATP ATL_NO
#endif
#ifndef USE_ATQ
#define USE_ATQ ATL_NO
#endif
#ifndef USE_ATA
#define USE_ATA ATL_NO
#endif
#ifndef USE_ATG
#define USE_ATG ATL_NO
#endif
#ifndef USE_ATF
#define USE_ATF ATL_NO
#endif
#ifndef USE_ATD
#define USE_ATD ATL_NO
#endif
#ifndef USE_ATZ
#define USE_ATZ ATL_NO
#endif
#ifndef USE_MNT
#define USE_MNT ATL_NO
#endif


/* This is not the Target Package compilation */
/* RTRT_TDP_COMPILATION is not defined : */
/* #define RTRT_TDP_COMPILATION */

#if USE_ATS || USE_ATK
/* Compilation options (from Studio settings) */
#include "options.h"
#endif

/* Values used by customization file */
#include "rtvalues.h"

/* What the Target Package implements */
#include "custom.h"

/* Defaults settings */
#include "atldefaults.h"

/* Init/exit header */
#include "initexit.h"

/* Clock management header */
#include "atlclock.h"

/* I/O and system routines header */
#include "priv.h"

/* Threads synchronization/protection objects management */
#include "tasking.h"

/* Presentation functions header */
#include "atlimage.h"

#if USE_ATP || USE_ATZ || USE_ATG || USE_ATA || USE_ATQ || USE_ATC || USE_ATT
/* Observation Tools common functions */
#include "obstools.h"

/* Call stack */
#include "rtstack.h"

#else /* USE_ATP || USE_ATZ || USE_ATG || USE_ATA || USE_ATQ || USE_ATC || USE_ATT */
#define _ATCPQ_DUMP(r)
#define _ATCPQ_DUMP_NAME(n)
#endif /* USE_ATP || USE_ATZ || USE_ATG || USE_ATA || USE_ATQ || USE_ATC || USE_ATT */

#if (USE_ATO || USE_ATK) && defined(ATL_CPLUSPLUS_INSTRUMENTOR)
/* Routines instrumentation macros */
#include "routinst.h"
#endif

#if USE_ATO
/* TestRT Object Testing specifics */
#include "ato.h"
#elif USE_ATV
/* TestRT Visual Testing specifics */
#include "atv.h"
#elif USE_ATS
/* TestRT System Testing specifics */
#include "ats.h"
#elif USE_ATU
/* TestRT Unit Testing specifics */
#include "atu.h"
#endif


#if USE_ATK
/* TestRT Contract Check specifics */
#include "atk.h"
#endif

#if USE_ATC
/* TestRT Coverage specifics */
#include "atc.h"
#endif

#if USE_ATT
/* TestRT Trace specifics */
#include "att.h"
#endif

#if USE_ATP || USE_ATZ || USE_ATG || USE_ATA
/* Common stack dump func */
#include "ata.h"
#endif

#if USE_ATP
/* TestRT PurifyLT specifics */
#include "atp.h"
#endif

#if USE_ATQ
/* TestRT QuantifyLT specifics */
#include "atq.h"
#endif

#if USE_ATG
/* TestRT ctrlCoupling specifics */
#include "atg.h"
/* must be included prior to atz.h */
#endif

#if USE_ATZ
/* TestRT stack size specifics */
#include "atz.h"
#endif

#if USE_MNT
/* TestRT Monitoring */
#include "mnt.h"
#endif

/* defines undefined macro */
#ifndef _ATL_TEST_CLASS_FRIEND
#define _ATL_TEST_CLASS_FRIEND
#endif /*_ATL_TEST_CLASS_FRIEND for #pragma attol class_friend = <className> */

#endif /* TP_H_INCLUDED */
