

/*
 *  Licensed Materials - Property of IBM
 *  Restricted Material of IBM
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2011 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


/*******************************************************************************
* $Descr: Unit Testing Header (included across TP.h) $
*******************************************************************************/

#ifndef ATU_H_INCLUDED
#define ATU_H_INCLUDED

#ifdef RTRT_INT64
/*! Largest representable signed integer */
/* see "image.c" ==>  _ATL_LARGEST_INT */
#define _ATU_LARGEST_INT RTRT_INT64
#else
#define _ATU_LARGEST_INT RTRT_INT32
#endif

#ifdef RTRT_U_INT64
/*! Largest representable unsigned integer */
/* see "image.c" ==>  _ATL_LARGEST_U_INT */
#define _ATU_LARGEST_U_INT RTRT_U_INT64
#else
#define _ATU_LARGEST_U_INT RTRT_U_INT32
#endif

#define atu_integer  _ATU_LARGEST_INT
#define atu_unsigned _ATU_LARGEST_U_INT
#define atl_memcpy priv_memcpy
#define ATU_INIT_DATA /* atu_init_data(); */
#define ATU_MEMCPY priv_memcpy
#define ATU_STRCPY atl_strcpy

#ifndef ATU_STUB_CNT
#define ATU_STUB_CNT RTRT_INT32
#endif
/*
#define ATU_STUB_ENTRY(s) atu_stub_entry(s)
#define ATU_STUB_EXIT(s)  atu_stub_exit()
*/
#define STUBCALL_NB    _at_call_order_Idx
#define STUBCALLORDERS _at_call_order

/* until 7.0.0 the rio filename was provided by the test driver */
/* Now, to be compliant to other tool the runtime provide the filename */
/* to come back to the previous solution define the following macro */
#ifdef PTU_PROVIDE_RIO_NAME
#define ATU_TRACES_FILE(file) char *atu_traces_file(void){return (file);}
#define ATL_SET_FILENAME_FUNC atu_traces_file
#else
#define ATU_TRACES_FILE(file)
#endif
/* the function CONCAT_STR_C require memory.
 * some TDP can disable this functionality
 */
#if ! RTRT_STR_CONCAT_SUPPORTED
#define CONCAT_STR_C(str,n) str
#endif
/**********************************************************/
/* MEMORY_SPACE represent the space memory where are      */
/* stored the strings. Default for this macro is empty    */
/**********************************************************/
#ifndef MEMORY_SPACE
#define MEMORY_SPACE
#endif

#ifndef ATU_STRING_SIZE
#define ATU_STRING_SIZE   1024
#endif

#ifndef NULL
#define NULL ((char *)(0))
#endif

#define PRIV_ABS(x) ((x) < 0 ? -(x) : (x))


extern char * atu_traces_file(
#if !RTRT_KR
void
#endif
) MEMORY_SPACE ;

#ifndef RTRT_TDP_COMPILATION

#define START_CHRONO_C() start_chrono_c(&start_chrono_c)

#ifndef RTRT_LOOPVAR_T
#define RTRT_LOOPVAR_T int
#endif

#if ATL_CPLUSPLUS_LANGUAGE
/* since 7.5 these vars are declared in the generated code for C */
#define I  I1
static RTRT_LOOPVAR_T I1;
static RTRT_LOOPVAR_T I2;
static RTRT_LOOPVAR_T I3;
static RTRT_LOOPVAR_T I4;
static RTRT_LOOPVAR_T I5;
static RTRT_LOOPVAR_T I6;
static RTRT_LOOPVAR_T I7;
#ifndef RTRT_IDXVAR_7_MAX
static RTRT_LOOPVAR_T I8;
static RTRT_LOOPVAR_T I9;
static RTRT_LOOPVAR_T I10;
static RTRT_LOOPVAR_T I11;
static RTRT_LOOPVAR_T I12;
static RTRT_LOOPVAR_T I13;
static RTRT_LOOPVAR_T I14;
static RTRT_LOOPVAR_T I15;
static RTRT_LOOPVAR_T I16;
static RTRT_LOOPVAR_T I17;
static RTRT_LOOPVAR_T I18;
static RTRT_LOOPVAR_T I19;
static RTRT_LOOPVAR_T I20;
#endif /* RTRT_IDXVAR_7_MAX */

#define J  J1
static RTRT_LOOPVAR_T J1;
static RTRT_LOOPVAR_T J2;
static RTRT_LOOPVAR_T J3;
static RTRT_LOOPVAR_T J4;
static RTRT_LOOPVAR_T J5;
static RTRT_LOOPVAR_T J6;
static RTRT_LOOPVAR_T J7;
#ifndef RTRT_IDXVAR_7_MAX
static RTRT_LOOPVAR_T J8;
static RTRT_LOOPVAR_T J9;
static RTRT_LOOPVAR_T J10;
static RTRT_LOOPVAR_T J11;
static RTRT_LOOPVAR_T J12;
static RTRT_LOOPVAR_T J13;
static RTRT_LOOPVAR_T J14;
static RTRT_LOOPVAR_T J15;
static RTRT_LOOPVAR_T J16;
static RTRT_LOOPVAR_T J17;
static RTRT_LOOPVAR_T J18;
static RTRT_LOOPVAR_T J19;
static RTRT_LOOPVAR_T J20;
#endif /* RTRT_IDXVAR_7_MAX */
#endif /* ATL_CPLUSPLUS_LANGUAGE */

#if 0
static void atu_init_data(
#if !RTRT_KR
void
#endif
)
{
   I1=0;  I2=0;  I3=0;  I4=0;  I5=0;  I6=0;  I7=0;
#ifndef RTRT_IDXVAR_7_MAX
   I8=0;  I9=0; I10=0;  I11=0; I12=0; I13=0; I14=0;
   I15=0; I16=0; I17=0; I18=0; I19=0; I20=0;
#endif /* RTRT_IDXVAR_7_MAX */
   J1=0;  J2=0;  J3=0;  J4=0;  J5=0;  J6=0;  J7=0;
#ifndef RTRT_IDXVAR_7_MAX
   J8=0;  J9=0; J10=0;  J11=0; J12=0; J13=0; J14=0;
   J15=0; J16=0; J17=0; J18=0; J19=0; J20=0;
#endif /* RTRT_IDXVAR_7_MAX */
}
#endif /* 0 */

#if !RTRT_CPLUSPLUS_LANGUAGE
#ifdef NEEDS_NUM_TEST_OPE
static int NUM_OPERATION, NUM_TEST;
#endif /*NEEDS_NUM_TEST_OPE*/
#endif /* !RTRT_CPLUSPLUS_LANGUAGE */

#endif

#ifndef atu_pointer

#if       RTRT_KR
#define atu_pointer char *
#else  /* RTRT_KR */
#define atu_pointer void *
#endif /* RTRT_KR */

#if       RTRT_64_BITS_PTR
#define _ATU_POINTER_CONVERSION RTRT_U_INT64
#else  /* RTRT_64_BITS_PTR */
#define _ATU_POINTER_CONVERSION RTRT_U_INT32
#endif /* RTRT_64_BITS_PTR */

#endif /* atu_pointer */

#ifndef _ATU_POINTER_CONVERSION
#error _ATU_POINTER_CONVERSION must be defined with atu_pointer
#endif /* _ATU_POINTER_CONVERSION */

#ifndef atu_charstring
#if RTRT_KR
#define atu_charstring char *
#else /* RTRT_KR */
#define atu_charstring RTRT_CONST_STRING_DECL
#endif /* RTRT_KR */
#endif /* atu_string */

#ifndef NIL
extern ATL_TP_PROTO_PREFIX atu_charstring NIL;
#endif

#ifndef NONIL
extern ATL_TP_PROTO_PREFIX atu_pointer NONIL;
#endif


/* check function pointers */
typedef void (*atu_funcpointer)(void);
#ifndef NONILFUNC
extern ATL_TP_PROTO_PREFIX atu_funcpointer NONILFUNC;
#endif

#ifndef NILFUNC
extern ATL_TP_PROTO_PREFIX atu_funcpointer   NILFUNC;
#endif

#if RTRT_CPLUSPLUS_LANGUAGE

#define CLF_CPP(name) STOP_CPP()
#define OPF_CPP(name) START_CPP()

class ATTOL_RUN {
public:
#ifdef NEEDS_NUM_TEST_OPE
  int NUM_OPERATION;
  int NUM_TEST;
#endif /*NEEDS_NUM_TEST_OPE*/
#if RTRT_STRING && RTRTUSE_STRING
#if RTRT_STR_CONCAT_SUPPORTED
  char * CONCAT_STR_CPP(atu_charstring, ...);
#endif /* RTRT_STR_CONCAT_SUPPORTED */
#endif /* RTRT_STRING ... */
#if RTRTUSE_PTU_UNSIGNED_C
  void atu_unsigned_cpp(atu_unsigned, int);
#endif /* RTRTUSE_PTU_UNSIGNED_C*/
#if RTRTUSE_PTU_BOOLEAN_C
  void atu_boolean_cpp(int, int);
#endif /* RTRTUSE_PTU_BOOLEAN_C */
#if RTRT_FLOAT && RTRTUSE_FLOAT
  void atu_float_cpp(float, int);
#endif /* RTRT_FLOAT && RTRTUSE_FLOAT */
#if RTRT_FLOAT && RTRTUSE_DOUBLE
  void atu_double_cpp(double, int);
#endif /* RTRT_FLOAT && RTRTUSE_DOUBLE */
#if RTRTUSE_EDV_STR_C
  void atu_edv_str_cpp( int, atu_charstring, int, atu_charstring, atu_charstring);
#endif /*RTRTUSE_EDV_STR_C*/
#if RTRTUSE_EDV_CHAR_C
  void atu_char_cpp(char, int);
  void atu_edv_char_cpp(int uncheck, char value, int num, char value_min, char value_max);
#endif /*RTRTUSE_EDV_CHAR_C*/
#if RTRTUSE_EDV_INTEGER_C
  void atu_edv_integer_cpp(int uncheck, atu_integer value, int num, atu_integer value_min, atu_integer value_max);
  void atu_integer_cpp(atu_integer value, int num);
#endif /*RTRTUSE_EDV_INTEGER_C*/
#if RTRTUSE_EDV_UNSIGNED_C
//  void atu_edv_unsigned_cpp(int, unsigned long, int, unsigned long, unsigned long);
  void atu_edv_unsigned_cpp(int uncheck, atu_unsigned value, int num, atu_unsigned value_min, atu_unsigned value_max);
#endif /*RTRTUSE_EDV_UNSIGNED_C*/
#if RTRTUSE_EDV_BOOLEAN_C
  void atu_edv_boolean_cpp(int uncheck, int value, int num, int value_min, int value_max);
#endif /*RTRTUSE_EDV_BOOLEAN_C*/
#if RTRTUSE_EDV_POINTER_C
#ifdef DISPLAYPTRVALUE
  void atu_edv_ptr_cpp(int uncheck, atu_pointer value, int num, atu_pointer value_att);
#else  /* DISPLAYPTRVALUE */
  inline void  atu_edv_ptr_cpp(int uncheck, atu_pointer ptr, int num, atu_pointer ref) {if(ref==ptr) atu_edv_ptrOK_cpp(num); else atu_edv_ptrKO_cpp(num, uncheck, (ptr==0),(NONIL==ref));}
  void atu_edv_ptrOK_cpp(int);
  void atu_edv_ptrKO_cpp(int,int,int,int);
#endif  /* DISPLAYPTRVALUE */
#endif /*RTRTUSE_EDV_POINTER_C*/
#if RTRTUSE_EDV_FLOAT_C
  void atu_edv_float_cpp(int uncheck, float value, int num, float value_min, float value_max);
#endif /*RTRTUSE_EDV_FLOAT_C*/
#if RTRTUSE_EDV_DOUBLE_C
  void atu_edv_double_cpp(int uncheck, double value, int num, double value_min, double value_max);
#endif /*RTRTUSE_EDV_DOUBLE_C*/
#if RTRTUSE_INI_STR_C
  void INI_STR_CPP(char *, int, long, atu_charstring);
#endif /*RTRTUSE_INI_STR_C*/

#if RTRTUSE_DCL_FAC_REP_C
  void DCL_FAC_REP_CPP(int, int);
#endif /*RTRTUSE_DCL_FAC_REP_C*/
#if RTRTUSE_ARRAY
  void UNSET_MODE_TAB_CPP(int);
  void SET_MODE_TAB_CPP(int);
#endif /*RTRTUSE_ARRAY*/
  void ERV_CPP(int);
  void START_CPP(void);
  void STOP_CPP(void);
  void EXCEP_CPP(int, atu_charstring = 0);
  void RUPT_CPP(int);
  void DCL_OP_CPP(int, atu_charstring);
  void DCL_TST_CPP(int, atu_charstring);
  void START_CHRONO_CPP();
  void STOP_CHRONO_CPP();
  void OPEN_BRA_CPP(int);
  void CLOSE_BRA_CPP(int);
#if RTRTUSE_CHRONO_MUET_C
  void EDV_CHRONO_MUET_CPP(int stub, int status, int num_app);
#endif /*RTRTUSE_CHRONO_MUET_C*/
#if RTRTUSE_MODE_CONSTANT
  void SET_MODE_CST_CPP(int);
  void UNSET_MODE_CST_CPP(int);
#endif /*RTRTUSE_MODE_CONSTANT*/
#if RTRTUSE_ARRAY
  void EDV_LST_ITEM_NOT_FOUND_CPP(atu_charstring, int);
  void EDV_LST_ITEM_NOT_EXPECTED_CPP(int);
  void EDV_LST_TEST_ITEM_CPP(atu_charstring, _atl_bool, int);
#endif /*RTRTUSE_ARRAY*/
};

#define PTU_CHAR_CPP(value, num) atu_char_cpp(value, num)
#define PTU_INTEGER_CPP(value, num, base) atu_integer_cpp(value, num)
#define PTU_UNSIGNED_CPP(value, num, base) atu_unsigned_cpp(value, num)
#define PTU_FLOAT_CPP(value, num) atu_float_cpp(value, num)
#define PTU_DOUBLE_CPP(value, num) atu_double_cpp(value, num)
#define PTU_LONG_DOUBLE_CPP(value, num) atu_double_cpp(value, num)
#define PTU_BOOLEAN_CPP(value, num) atu_boolean_cpp(value, num)
#define EDV_CHAR_CPP(aff_interv, uncheck, value, num, value_min, value_max) atu_edv_char_cpp(uncheck, value, num, value_min, value_max)
#define EDV_UNSIGNED_CPP(aff_interv, uncheck, value, num, base, value_min, value_max) atu_edv_unsigned_cpp(uncheck, value, num, value_min, value_max)
#define EDV_INTEGER_CPP(aff_interv, uncheck, value, num, base, value_min, value_max) atu_edv_integer_cpp(uncheck, value, num, value_min, value_max)
#define EDV_FLOAT_CPP(aff_interv, uncheck, value, num, value_min, value_max) atu_edv_float_cpp(uncheck, value, num, value_min, value_max)
#define EDV_DOUBLE_CPP(aff_interv, uncheck, value, num, value_min, value_max) atu_edv_double_cpp(uncheck, value, num, value_min, value_max)
#define EDV_LONG_DOUBLE_CPP(aff_interv, uncheck, value, num, value_min, value_max) atu_edv_double_cpp(uncheck, value, num, value_min, value_max)
#define EDV_BOOLEAN_CPP(aff_interv, uncheck, value, num, value_min, value_max) atu_edv_boolean_cpp(uncheck, value, num, value_min, value_max)
#define EDV_POINTER_CPP(aff_interv, uncheck, value, num, value_att) atu_edv_ptr_cpp(uncheck, value, num, value_att)
#define EDV_STR_CPP(aff_interv, uncheck, value, num, value_min, value_max) atu_edv_str_cpp(uncheck, value, num, value_min, value_max)
#define ATU_END_TEST_CPP()

/* CONTAINER */
#define ATW_LST_EMPTY(lst) lst.empty()

/* SEQUENCE */
#define ATW_LST_CLEAR(lst) lst.clear()
#define ATW_LST_FRONT(lst) lst.front()
#define ATW_LST_ERASE_BEGIN(lst) lst.erase(lst.begin())
#define ATW_LST_INSERT_BEGIN(lst, val) lst.insert(lst.begin(), val)

/*
 * Type requirements for lst : Equality Comparable
 * A type is EqualityComparable if objects of that type can be compared for equality using operator==,
 * and if operator== is an equivalence relation
 */
#define ATW_LST_COMPARE(v1, v2) ((v1) == (v2))

/* Exception copy */
#define ATW_EXCEP_REFCPY(e1, e2) ((*e1) = ( e2))
#define ATW_EXCEP_PTRCPY(e1, e2) ((e1) = (e2))

#ifndef RTRT_TDP_COMPILATION
static ATTOL_RUN attol_run;
#endif

#else /* RTRT_CPLUSPLUS_LANGUAGE */

#define OPF_C(name) START_C()
#define CLF_C(name) STOP_C()

#if RTRT_STRING

#if RTRT_STR_CONCAT_SUPPORTED

extern ATL_TP_PROTO_PREFIX char * CONCAT_STR_C(
#if !RTRT_KR
  atu_charstring str,
  ...
#endif
) MEMORY_SPACE ;

#endif /* RTRT_STR_CONCAT_SUPPORTED */

#endif /* RTRT_STRING */

extern ATL_TP_PROTO_PREFIX void atu_char_c(
#if !RTRT_KR
  char value,
  int num
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void atu_integer_c(
#if !RTRT_KR
  atu_integer value,
  int num
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void atu_unsigned_c(
#if !RTRT_KR
  atu_unsigned value,
  int num
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void atu_boolean_c(
#if !RTRT_KR
  int value,
  int num
#endif
) MEMORY_SPACE ;

#if RTRT_FLOAT

extern ATL_TP_PROTO_PREFIX void atu_float_c(
#if !RTRT_KR
  float value,
  int num
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void atu_double_c(
#if !RTRT_KR
  double value,
  int num
#endif
) MEMORY_SPACE ;

#endif /* RTRT_FLOAT */

#if RTRT_STRING

extern ATL_TP_PROTO_PREFIX void atu_edv_str(
#if !RTRT_KR
  int uncheck,
  atu_charstring value,
  int num,
  atu_charstring value_min,
  atu_charstring value_max
#endif
) MEMORY_SPACE ;

#endif /* RTRT_STRING */

extern ATL_TP_PROTO_PREFIX void atu_edv_char(
#if !RTRT_KR
  int uncheck,
  char value,
  int num,
  char value_min,
  char value_max
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void atu_edv_integer(
#if !RTRT_KR
  int uncheck,
  atu_integer value,
  int num,
  atu_integer value_min,
  atu_integer value_max
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void atu_edv_unsigned(
#if !RTRT_KR
  int uncheck,
  atu_unsigned value,
  int num,
  atu_unsigned value_min,
  atu_unsigned value_max
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void atu_edv_boolean(
#if !RTRT_KR
  int uncheck,
  int value,
  int num,
  int value_min,
  int value_max
#endif
) MEMORY_SPACE ;

#ifdef DISPLAYPTRVALUE
extern ATL_TP_PROTO_PREFIX void atu_edv_ptr(
#if !RTRT_KR
  int uncheck,
  atu_pointer value,
  int num,
  atu_pointer value_att
#endif
) MEMORY_SPACE ;
#endif /* DISPLAYPTRVALUE */

extern ATL_TP_PROTO_PREFIX void atu_edv_ptrKO(
#if !RTRT_KR
  int num,
  int uncheck,
  int isNIL,
  int isRefNONIL
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void atu_edv_ptrOK(
#if !RTRT_KR
  int num
#endif
) MEMORY_SPACE ;


#if RTRT_FLOAT

extern ATL_TP_PROTO_PREFIX void atu_edv_float(
#if !RTRT_KR
  int uncheck,
  float value,
  int num,
  float value_min,
  float value_max
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void atu_edv_double(
#if !RTRT_KR
  int uncheck,
  double value,
  int num,
  double value_min,
  double value_max
#endif
) MEMORY_SPACE ;

#endif /* RTRT_FLOAT */
extern ATL_TP_PROTO_PREFIX void atu_op(
#if !RTRT_KR
  int num  ,
  atu_charstring name_op
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void atu_tst(
#if !RTRT_KR
  int num  ,
  atu_charstring name_tst
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void start_chrono_c(
#if !RTRT_KR
  void *
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void STOP_CHRONO_C(
#if !RTRT_KR
  void
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void START_C(
#if !RTRT_KR
  void
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void STOP_C(
#if !RTRT_KR
  void
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void SET_MODE_TAB_C(
#if !RTRT_KR
  int num
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void UNSET_MODE_TAB_C(
#if !RTRT_KR
  int num
#endif
) MEMORY_SPACE ;

#if RTRT_STRING

extern ATL_TP_PROTO_PREFIX void atu_ini_str(
#if !RTRT_KR
  char * s,
  int  aff_val,
  long num,
  atu_charstring val
#endif
) MEMORY_SPACE ;

#endif /* RTRT_STRING */

extern ATL_TP_PROTO_PREFIX void RUPT (
#if !RTRT_KR
  int niveau
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void DCL_FAC_REP_C(
#if !RTRT_KR
  int num,
  int facteur
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void SET_MODE_CST_C(
#if !RTRT_KR
  int num
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void UNSET_MODE_CST_C(
#if !RTRT_KR
  int num
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void ATTOL_OPEN_BRA_C(
#if !RTRT_KR
  int num
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void ATTOL_CLOSE_BRA_C(
#if !RTRT_KR
  int num
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void edv_chrono_muet_c(
#if !RTRT_KR
  int stub,
  int a_status,
  int num_app
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void EDV_MUET_CHECK(
#if !RTRT_KR
  int stub,
  int ind
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX int COMP_STR_C(
#if !RTRT_KR
atu_charstring  atu_s1,
atu_charstring  atu_s2
#endif
) MEMORY_SPACE;

#if RTRT_VARIABLE_INIT_SUPPORTED
#ifndef STUBINACTIVE
#define STUBINACTIVE = -1
#endif
#else
#ifndef STUBINACTIVE
#define STUBINACTIVE 
#endif
#define ATU_GLOBAL_STUB_INITIALISED(X) ATU_global_stub_initialised
#define ATU_GLOBAL_STUB_INITIALISE char ATU_global_stub_initialised;
#define ATU_GLOBAL_STUB_INIT ATU_global_stub_initialised=1;

#endif /*RTRT_VARIABLE_INIT_SUPPORTED*/
#define PTU_CHAR_C(value, num) atu_char_c(value, num)
#define PTU_INTEGER_C(value, num, base) atu_integer_c(value, num)
#define PTU_UNSIGNED_C(value, num, base) atu_unsigned_c(value, num)
#define PTU_FLOAT_C(value, num) atu_float_c(value, num)
#define PTU_DOUBLE_C(value, num) atu_double_c(value, num)
#define PTU_BOOLEAN_C(value, num) atu_boolean_c(value, num)

#ifndef DCL_OP_C
#if RTRT_TINY_TARGET
#define DCL_OP_C(num, name_op) atu_op(num, (char *)0)
#else
#define DCL_OP_C(num, name_op) atu_op(num, name_op)
#endif
#endif
#ifndef DCL_TST_C
#if RTRT_TINY_TARGET
#define DCL_TST_C(num, name_tst) atu_tst(num, (char *)0)
#else
#define DCL_TST_C(num, name_tst) atu_tst(num, name_tst)
#endif
#endif

#define EDV_STR_C(aff_interv, uncheck, value, num, value_min, value_max) atu_edv_str(uncheck, value, num, value_min, value_max)
#define EDV_CHAR_C(aff_interv, uncheck, value, num, value_min, value_max) atu_edv_char(uncheck, value, num, value_min, value_max)
#define EDV_UNSIGNED_C(aff_interv, uncheck, value, num, base, value_min, value_max) atu_edv_unsigned(uncheck, value, num, value_min, value_max)
#define EDV_INTEGER_C(aff_interv, uncheck, value, num, base, value_min, value_max) atu_edv_integer(uncheck, value, num, value_min, value_max)
#define EDV_FLOAT_C(aff_interv, uncheck, value, num, value_min, value_max) atu_edv_float(uncheck, value, num, value_min, value_max)
#define EDV_DOUBLE_C(aff_interv, uncheck, value, num, value_min, value_max) atu_edv_double(uncheck, value, num, value_min, value_max)
#define EDV_BOOLEAN_C(aff_interv, uncheck, value, num, value_min, value_max) atu_edv_boolean(uncheck, value, num, value_min, value_max)
#ifdef DISPLAYPTRVALUE
#define EDV_POINTER_C(aff_interv, uncheck, value, num, value_att) atu_edv_ptr(uncheck, value, num, value_att)
#else /* DISPLAYPTRVALUE */
#define EDV_POINTER_C(aff_interv, uncheck, ptr, num, ref) if(ref==ptr) atu_edv_ptrOK(num); else atu_edv_ptrKO(num, uncheck, (ptr==0),(NONIL==ref))
#endif /* DISPLAYPTRVALUE */
#define EDV_FUNCPOINTER_C(aff_interv, uncheck, ptr, num, ref)  if((atu_funcpointer)ref==(atu_funcpointer)ptr) atu_edv_ptrOK(num); else atu_edv_ptrKO(num, uncheck, (ptr==0),(NONILFUNC==(atu_funcpointer)ref))
#define EDV_NILFUNCPOINTER_C(aff_interv, uncheck, ptr, num, ref)  if(ptr==0) atu_edv_ptrOK(num); else atu_edv_ptrKO(num, uncheck, 0,0)
#define EDV_NONILFUNCPOINTER_C(aff_interv, uncheck, ptr, num, ref)  if(ptr==0) atu_edv_ptrKO(num, uncheck, 1,1); else atu_edv_ptrOK(num)
#define _ATCC_FUNCPTR(ptr,ref)    ((NONILFUNC==(atu_funcpointer)ref)?(!(ptr)):(ref!=ptr))

#define INI_STR_C(s, aff_val, num, val) atu_ini_str(s, aff_val, num, val)
#define EDV_CHRONO_MUET_C(s,st,num) edv_chrono_muet_c(s,st,num)
#define ATU_END_TEST_C()

#endif /* !RTRT_CPLUSPLUS_LANGUAGE */
#endif /* ATU_H_INCLUDED */
