

/*
 *  Licensed Materials - Property of IBM
 *  Restricted Material of IBM
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2011 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


/*******************************************************************************
* $Descr: QuantifyLT Header (included across TP.h) $
*******************************************************************************/


/* Multiple inclusions guard: */
#ifndef ATZ_H_INCLUDED
#define ATZ_H_INCLUDED

#define _ATZ_INIT_FUNC(i) RTRT_CONCAT_MACRO(_atz_init_func,i)
#define _ATZ_INIT_DONE(i) RTRT_CONCAT_MACRO(_atz_init_done,i)

/*******************************************************************************
*  C/C++ Instrumentor
*******************************************************************************/
#if ATL_DYN_TABLE
#if RTRT_HEAP != RTRT_NONE
#ifndef _ATZ_ALLOC
#define _ATZ_ALLOC(n,s) priv_malloc(n*s)
#define _ATZ_FREE(p) priv_free(p)
#endif /* _ATZ_ALLOC */


#define RTRT_ATZ_DECLARE_OVERLOAD(i,n) \
static _atz_TP ATL_SET_MEM _ATZ_DATA(i) ATL_SET_SECTION ; \
static unsigned char ATL_SET_MEM _ATZ_INIT_DONE(i) ATL_SET_SECTION ATL_OBSTOOLS_INITIALIZE_TO_ZERO; \
static void _ATZ_INIT_FUNC(i)(void)   { \
  if( RTRT_IS_NOT_INITIALIZED(_ATZ_INIT_DONE(i))) \
  { \
    _ATZ_INIT_DONE(i)=RTRT_VARIABLE_INITIALIZED; \
    _ATZ_DATA(i)=(_atz_TP)_ATZ_ALLOC(1,sizeof(_atz_T)); \
    _ATZ_DATA(i)->Key=0; \
    _ATZ_DATA(i)->CheckSum=0; \
    _ATZ_DATA(i)->Routines=n; \
    _ATZ_DATA(i)->StackSizes=(RTRT_U_INT32*)_ATZ_ALLOC(n,sizeof(RTRT_SP_SIZE_VAR_T)); \
    _ATZ_DATA(i)->Next=(_atz_TP)0; \
  } }

#define _ATZ_INIT_CALL(i) _ATZ_INIT_FUNC(i)();

#ifndef _ATZ_DATA_PTR
#define _ATZ_STACKSIZE_TABLE(i)        _ATZ_DATA(i)->StackSizes
#define _ATZ_DATA_PTR(i)           (_ATZ_DATA(i))
#endif /* _ATZ_DATA_PTR */


#else /* RTRT_HEAP != RTRT_NONE */
#error "Dynamic table useless for TDP having RTRT_HEAP to NONE"
#endif /* RTRT_HEAP != RTRT_NONE */
#else /* ATL_DYN_TABLE */

#if !RTRT_VARIABLE_INIT_SUPPORTED

#define RTRT_ATZ_DECLARE_OVERLOAD(i,n) \
static RTRT_SP_SIZE_VAR_T ATL_SET_MEM _ATZ_STACKSIZE_TABLE(i)[n] ATL_SET_SECTION; \
static _atz_T ATL_SET_MEM _ATZ_DATA(i) ATL_SET_SECTION; \
static unsigned char ATL_SET_MEM _ATZ_INIT_DONE(i) ATL_SET_SECTION ATL_OBSTOOLS_INITIALIZE_TO_ZERO; \
static void _ATZ_INIT_FUNC(i)(void)   { \
  if( RTRT_IS_NOT_INITIALIZED(_ATZ_INIT_DONE(i))) \
  { \
    _ATZ_INIT_DONE(i)=RTRT_VARIABLE_INITIALIZED; \
    _ATZ_DATA(i).Source=(_AtlStackSourceP)0; \
    _ATZ_DATA(i).Routines=n; \
    _ATZ_DATA(i).StackSizes=&_ATZ_STACKSIZE_TABLE(i)[0]; \
    _ATZ_DATA(i).Next=(_atz_TP)0; \
  } }

#define _ATZ_INIT_CALL(i) _ATZ_INIT_FUNC(i)();

#else /* RTRT_VARIABLE_INIT_SUPPORTED */

#define _ATZ_INIT_CALL(i)

#endif /* RTRT_VARIABLE_INIT_SUPPORTED */
#endif /* ATL_DYN_TABLE */

typedef struct _atz_T_ {
#if ATL_DYN_TABLE
        RTRT_U_INT32              Key;
        RTRT_U_INT32              CheckSum;
#else /* ATL_DYN_TABLE */
        _AtlStackSourceP              Source;
#endif /* ATL_DYN_TABLE */
        RTRT_U_INT32                  Routines;
        RTRT_SP_SIZE_VAR_T           *StackSizes;
        struct _atz_T_               *Next;
} _atz_T, *_atz_TP;

#define _ATZ_DATA(i)               RTRT_CONCAT_MACRO(_atz_data,i)

#ifndef _ATZ_DATA_PTR
#define _ATZ_STACKSIZE_TABLE(i)        RTRT_CONCAT_MACRO(_atz_stacksize_table,i)
#define _ATZ_DATA_PTR(i)           &(_ATZ_DATA(i))
#endif /* _ATZ_DATA_PTR */

#ifndef RTRT_ATZ_DECLARE_OVERLOAD
#define _ATZ_DECLARE(i,n) \
static RTRT_SP_SIZE_VAR_T ATL_SET_MEM _ATZ_STACKSIZE_TABLE(i)[n] ATL_SET_SECTION; \
static _atz_T ATL_SET_MEM_CONST _ATZ_DATA(i) ATL_SET_SECTION_CONST = { \
                               (_AtlStackSourceP)0, \
                               n, \
                               &_ATZ_STACKSIZE_TABLE(i)[0], \
                               (_atz_TP)0 \
                             };
#else /* RTRT_ATZ_DECLARE_OVERLOAD */
#define _ATZ_DECLARE(i,n) \
  RTRT_ATZ_DECLARE_OVERLOAD(i,n)
#endif /* RTRT_ATZ_DECLARE_OVERLOAD */

/*******************************************************************************
*  C++ Instrumentor
*******************************************************************************/
#if RTRT_CPLUSPLUS_LANGUAGE
#define _ATZ_DEFINE_CLASS_IN(i) 

#define _ATZ_IN(i) \
  _ATZ_INIT_CALL(i) \
  _atl_stack_object._atl_stack_link.AtzData = (void *)(_ATZ_DATA_PTR(i)); \
  _atz_start(&_atl_stack_object._atl_stack_link);
  
#define _ATZ_CALL(o,n) \
  _atl_stack_measure(&_atl_stack_object._atl_stack_link)

#define _ATZ_MEASURE() _atl_stack_measure(&_atl_stack_object._atl_stack_link),

#else /*RTRT_CPLUSPLUS_LANGUAGE*/
/*******************************************************************************
*  C/C++ Instrumentor
*******************************************************************************/

/* i is source number */
#define _ATZ_IN(i) \
  _ATZ_INIT_CALL(i) \
  _atl_stack_link.AtzData = (void *)(_ATZ_DATA_PTR(i)); \
  _atz_start(&_atl_stack_link);

#define _ATZ_CALL(o,n) \
  _atl_stack_measure(&_atl_stack_link)

#define _ATZ_MEASURE() _atl_stack_measure(&_atl_stack_link),
#endif /*RTRT_CPLUSPLUS_LANGUAGE*/




/*******************************************************************************
* Functions prototypes:
*******************************************************************************/

#if !RTRT_KR

_ATL_EXTERN_C ATL_TP_PROTO_PREFIX void atz_set( _AtlStackLinkP , RTRT_SP_SIZE_VAR_T );
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX void _atl_stack_measure(_AtlStackLinkP);
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX void _atz_start( _AtlStackLinkP);

#else /* RTRT_KR */

_ATL_EXTERN_C ATL_TP_PROTO_PREFIX void atz_set();
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX void _atl_stack_measure();
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX void _atz_start();
#endif /* RTRT_KR */

#endif /* ATZ_H_INCLUDED */

