

/*
 *  Licensed Materials - Property of IBM
 *  Restricted Material of IBM
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2011 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


/*******************************************************************************
* $Descr: Studio-modifiable Settings (Parsed by Products.pl) $
* This file cannot be copied as products.h directly.
* To make a products.h: use the command line tool
* attolcc <options> <settings> -env_ATL_NO_TDP_COMPILE=1 -force_tdp_cc
* attolcc --help will provide all available options and settings and example of use
*******************************************************************************/

/* Multiple inclusions guard: */
#ifndef PRODUCTS_MODEL_H_INCLUDED
#define PRODUCTS_MODEL_H_INCLUDED


#define ATL_YES      1
#define ATL_NO       0

/* WARNING:
     #define lines are updated by Perl script ! */

/* Use TestRT Unit Testing */
#ifndef USE_ATU
#define USE_ATU { $ATUMODE } ATL_YES|ATL_NO
#endif
/* Use TestRT Visual Test */
#ifndef USE_ATV
#define USE_ATV { $ATVMODE } ATL_YES|ATL_NO
#endif
/* Use TestRT System Testing */
#ifndef USE_ATS
#define USE_ATS { $ATSMODE || $ATS_PROBE_CUSTOM } ATL_YES|ATL_NO
#endif
/* Use TestRT Object Testing */
#ifndef USE_ATO
#define USE_ATO { $ATOMODE } ATL_YES|ATL_NO
#endif
/* Use TestRT Contract Check */
#ifndef USE_ATK
#define USE_ATK { $ATKMODE } ATL_YES|ATL_NO
#endif
/* Use TestRT Coverage */
#ifndef USE_ATC
#define USE_ATC { $ATCMODE || $DCPMODE || ($ATGMODE && !$ATG_MODULE_AS) } ATL_YES|ATL_NO
#endif
/* Use TestRT Trace */
#ifndef USE_ATT
#define USE_ATT { $ATTMODE } ATL_YES|ATL_NO
#endif
/* Use TestRT Purify HEAP */
#ifndef USE_ATP
#define USE_ATP { $ATPMODE && !defined $Ini{ATPMODE} } ATL_YES|ATL_NO
#endif
/* Use TestRT QuantifyLT */
#ifndef USE_ATQ
#define USE_ATQ { $ATQMODE && !defined $Ini{ATQMODE} } ATL_YES|ATL_NO
#endif
/* Use TestRT Application Profiling > FIU or SIG detection */
#ifndef USE_ATA
#define USE_ATA { $ATAMODE && ($ATP_REPORTS_FIU || $ATP_REPORTS_SIG) } ATL_YES|ATL_NO
#endif
/* Use TestRT CCoupling Compilation Unit*/
#ifndef USE_ATG
#define USE_ATG { $ATGMODE && $ATG_MODULE_AS && !defined $Ini{USE_ATTOLCC1} } ATL_YES|ATL_NO
#endif
/* Use TestRT CCoupling Function */
#ifndef USE_ATF
#define USE_ATF { $ATGMODE && !$ATG_MODULE_AS && !defined $Ini{USE_ATTOLCC1} } ATL_YES|ATL_NO
#endif
/* Use TestRT DataCoupling */
#ifndef USE_ATD
#define USE_ATD { $DCPMODE && !defined $Ini{USE_ATTOLCC1} } ATL_YES|ATL_NO
#endif
/* Use TestRT Stack Size */
#ifndef USE_ATZ
#define USE_ATZ { $ATAMODE && $ATZMODE && !defined $Ini{USE_ATTOLCC1} } ATL_YES|ATL_NO
#endif
/* Use TestRT Monitoring */
#ifndef USE_MNT
#define USE_MNT { $ATAMODE && $MNTMODE && !defined $Ini{USE_ATTOLCC1} } ATL_YES|ATL_NO
#endif

#ifndef USE_ATU
#define USE_ATU ATL_NO
#endif
#ifndef USE_ATV
#define USE_ATV ATL_NO
#endif
#ifndef USE_ATS
#define USE_ATS ATL_NO
#endif
#ifndef USE_ATO
#define USE_ATO ATL_NO
#endif
#ifndef USE_ATK
#define USE_ATK ATL_NO
#endif
#ifndef USE_ATC
#define USE_ATC ATL_NO
#endif
#ifndef USE_ATT
#define USE_ATT ATL_NO
#endif
#ifndef USE_ATP
#define USE_ATP ATL_NO
#endif
#ifndef USE_ATQ
#define USE_ATQ ATL_NO
#endif
#ifndef USE_ATA
#define USE_ATA ATL_NO
#endif
#ifndef USE_ATG
#define USE_ATG ATL_NO
#endif
#ifndef USE_ATF
#define USE_ATF ATL_NO
#endif
#ifndef USE_ATD
#define USE_ATD ATL_NO
#endif
#ifndef USE_ATZ
#define USE_ATZ ATL_NO
#endif
#ifndef USE_MNT
#define USE_MNT ATL_NO
#endif



/*******************************************************************************
* TestRT Unit Testing:
*******************************************************************************/


#define ATU_BREAK_ON_TEST_FAILED { $ATU_BREAK_ON_TEST_FAILED } ATL_NO|ATL_YES
#ifndef ATU_BREAK_ON_TEST_FAILED
/*! Calls a breakpoint function on an error if 1 */
#define ATU_BREAK_ON_TEST_FAILED ATL_NO
#endif

#ifndef __cplusplus
#if USE_ATU
/* file regenrated by attolpreproC for runtime optimization */
@TST@ ATU_OPTIM_INCLUDE attol_cfg.h
#endif
#endif
/*******************************************************************************
* TestRT Visual Test:
*******************************************************************************/


#define ATV_BREAK_ON_TEST_FAILED { $ATV_BREAK_ON_TEST_FAILED } ATL_NO|ATL_YES
#ifndef ATV_BREAK_ON_TEST_FAILED
/*! Calls a breakpoint function on an error if 1 */
#define ATV_BREAK_ON_TEST_FAILED ATL_NO
#endif

#if USE_ATV
/* file generated by ATV for runtime optimization */
@TST@ ATV_OPTIM_INCLUDE test_harness.h
#endif

#define ATV_REPORT_OUTLAY { $ATU_REPORT_OUTLAY } num 0|1|2
#ifndef ATV_REPORT_OUTLAY
/*! standard mode expand arrays */
#define ATV_REPORT_OUTLAY 0
#endif

/*******************************************************************************
* TestRT System Testing:
*******************************************************************************/


#define ATS_BUFFER_SIZE { $ATS_BUFFER_SIZE } <number>
#ifndef ATS_BUFFER_SIZE
/*! Size in bytes of buffer (used to store string vars and lines) */
#define ATS_BUFFER_SIZE 1024
#endif

#define ATS_TAGTBUF_SIZE { $ATS_TAGTBUF_SIZE } <number>
#ifndef ATS_TAGTBUF_SIZE
/*! Maximum size in bytes of lines raised by testers */
#define ATS_TAGTBUF_SIZE 4096
#endif

#define ATS_RT_BUFFER { $ATS_RT_BUFFER } ATL_YES|ATL_NO
#ifndef ATS_RT_BUFFER
/*! Use bufferized items */
#define ATS_RT_BUFFER ATL_NO
#endif

#define ATS_DYNFLW { $ATS_DYN_FOLLOW && !$ATS_NO_SPV } ATL_YES|ATL_NO
#ifndef ATS_DYNFLW
/*! Activates dynamic tracking */
#define ATS_DYNFLW ATL_NO
#endif

#define ATS_INTERRECV_TIMEOUT { $ATS_INTERRECV_TIMEOUT } <number>
#ifndef ATS_INTERRECV_TIMEOUT
/*! Timeout for INTERRECV instruction */
#define ATS_INTERRECV_TIMEOUT 300
#endif

#define ATS_THREAD_LAUNCHER { $ATS_THREAD && $ATS_THREAD_LAUNCHER } ATL_YES|ATL_NO
#ifndef ATS_THREAD_LAUNCHER
/*! Timeout for INTERRECV instruction */
#define ATS_THREAD_LAUNCHER ATL_YES
#endif

@TST@  ATS_THREAD_FUNCTION <ATL_Start>
#ifndef ATS_THREAD_FUNCTION
/*! Timeout for INTERRECV instruction */
#define ATS_THREAD_FUNCTION ATL_Start
#define ATS_THREAD_TABLE ATL_Start_Table
#define ATS_THREAD_TABLELEN ATL_Start_TableLen
#endif

/*******************************************************************************
* TestRT Object Testing:
*******************************************************************************/


#define ATO_BREAK_ON_CHECK_FAILED { $ATO_STOP_ON_ERROR } ATL_NO|ATL_YES
#ifndef ATO_BREAK_ON_CHECK_FAILED
/*! Calls a breakpoint function on an error if 1 */
#define ATO_BREAK_ON_CHECK_FAILED ATL_NO
#endif

#define ATO_DUMP_SUCCESS { $ATO_DUMP_SUCCESS } ATL_NO|ATL_YES
#ifndef ATO_DUMP_SUCCESS
/*! Also dumps successful checks in traces */
#define ATO_DUMP_SUCCESS 1
#endif

#define ATO_MAX_INSTANCES { $ATO_MAX_INSTANCES } <number>
#ifndef ATO_MAX_INSTANCES
/*! Size of instances stack */
#define ATO_MAX_INSTANCES 256
#endif

#define ATO_PRINT_BUFFER_SIZE { $ATO_PRINT_BUFFER_SIZE } <number>
#ifndef ATO_PRINT_BUFFER_SIZE
/* Size of PRINT buffer (0 means no buffering: PRINT arguments are displayed
 * on separate notes) */
#define ATO_PRINT_BUFFER_SIZE 512
#endif


/*******************************************************************************
* TestRT Contract Check:
*******************************************************************************/


#define ATK_BREAK_ON_ASSERT_FAILED { $ATK_STOP_ON_ERROR } ATL_NO|ATL_YES
#ifndef ATK_BREAK_ON_ASSERT_FAILED
/*! Calls a breakpoint function on an error if 1 */
#define ATK_BREAK_ON_ASSERT_FAILED 0
#endif

#define ATK_DUMP_SUCCESS { $ATK_DUMP_SUCCESS } ATL_NO|ATL_YES
#ifndef ATK_DUMP_SUCCESS
/*! Also dumps successful assertions in traces */
#define ATK_DUMP_SUCCESS 0
#endif



/*******************************************************************************
* TestRT Coverage:
*******************************************************************************/


/* 0: pass mode,
 * 1: compact mode,
 * 2: count mode */
#define ATC_INFORMATION { $ATCMODE ? $ATC_INFORMATION : 0 } num 0|1|2
#ifndef ATC_INFORMATION
/* pass mode */
#define ATC_INFORMATION 0
#endif

#define ATC_DUMP_DRIVER { $ATC_DUMP_DRIVER || lc($ATC_DUMP_DRIVER) eq 'merged' } ATL_YES|ATL_NO
#ifndef ATC_DUMP_DRIVER
/* Dump Driver use */
#define ATC_DUMP_DRIVER ATL_NO
#endif

#define ATC_ON_THE_FLY { $ATC_ON_THE_FLY } <number>
#ifndef ATC_ON_THE_FLY
#define ATC_ON_THE_FLY 0
#endif


/*******************************************************************************
* TestRT Trace:
*******************************************************************************/


#define ATT_ON_THE_FLY { $ATT_ON_THE_FLY } ATL_YES|ATL_NO
#ifndef ATT_ON_THE_FLY
/* Trace On The Fly (natives only) */
#define ATT_ON_THE_FLY ATL_YES
#endif

#define ATT_ITEMS_MAX { $ATT_ITEM_BUFFER ? $ATT_ITEM_BUFFER_SIZE : 0 } <number>
#ifndef ATT_ITEMS_MAX
/* Maximum Number of Buffered Items */
#define ATT_ITEMS_MAX 0
#endif

#define ATT_DUMP_FROM_BEGINNING { !$ATT_PARTIAL_DUMP } ATL_YES|ATL_NO
#ifndef ATT_DUMP_FROM_BEGINNING
/* No Partial Message Dump: if ATL_YES, message dump starting, stopping and
   toggling and stack dump are not available */
#define ATT_DUMP_FROM_BEGINNING ATL_YES
#endif

/* Action Associated to Signal Handling */
#define ATT_SIGNAL_TOGGLE_DUMP 1
#define ATT_SIGNAL_DUMP_CALL_STACK 2

#define ATT_SIGNAL { $ATT_SIGNAL_ACTION } num ATL_NO|ATT_SIGNAL_TOGGLE_DUMP|ATT_SIGNAL_DUMP_CALL_STACK
#ifndef ATT_SIGNAL
/* Possible Values for ATT_SIGNAL:
   ATL_NO, ATT_SIGNAL_TOGGLE_DUMP or ATT_SIGNAL_DUMP_CALL_STACK */
#define ATT_SIGNAL ATL_NO
#endif

#define ATT_COMPUTE_MAX_CALLING_LEVEL { $ATT_RECORD_MAX_STACK } ATL_YES|ATL_NO
#ifndef ATT_COMPUTE_MAX_CALLING_LEVEL
/* Computes Maximum Call Stack Size and Display it in a Note */
#define ATT_COMPUTE_MAX_CALLING_LEVEL ATL_NO
#endif

#define ATT_TIMESTAMP { $ATT_TIMESTAMP && !defined $Ini{ATQMODE} } ATL_YES|ATL_NO
#ifndef ATT_TIMESTAMP
/* Time Stamping of UML/SD Messages: */
#define ATT_TIMESTAMP ATL_NO
#endif

#define ATT_HEAPSIZESTAMP { $ATT_HEAP_SIZE && !defined $Ini{ATPMODE} } ATL_YES|ATL_NO
#ifndef ATT_HEAPSIZESTAMP
#define ATT_HEAPSIZESTAMP ATL_YES
#endif

/* multi-threaded applications only: */

#define ATT_THREAD_INFO { $ATT_THREAD_INFO } ATL_YES|ATL_NO
#ifndef ATT_THREAD_INFO
/* thread info is computed or not */
#define ATT_THREAD_INFO ATL_NO
#endif



/*******************************************************************************
* TestRT PurifyLT:
*******************************************************************************/


#define ATP_CALL_STACK_SIZE { $ATP_CALL_STACK_SIZE } <number>
#ifndef ATP_CALL_STACK_SIZE
/* How Many Call Stack Items in each Memory Block Description */
#define ATP_CALL_STACK_SIZE 6
#endif

#define ATP_REPORTS_FIU { $ATP_REPORTS_FIU } ATL_YES|ATL_NO
#ifndef ATP_REPORTS_FIU
/* File In Use Reporting */
#define ATP_REPORTS_FIU ATL_NO
#endif

#define ATP_REPORTS_FFM_FMWL { $ATP_REPORTS_FFM_FMWL } ATL_YES|ATL_NO
#ifndef ATP_REPORTS_FFM_FMWL
/* Late Detect Free Memory Write Reporting */
#define ATP_REPORTS_FFM_FMWL ATL_YES
#endif

#define ATP_REPORTS_FIM { $ATP_REPORTS_FIM } ATL_YES|ATL_NO
#ifndef ATP_REPORTS_FIM
/* Late Detect Free Memory Write Reporting */
#define ATP_REPORTS_FIM ATL_NO
#endif

#define ATP_MAX_FREEQ_LENGTH { $ATP_MAX_FREEQ_LENGTH } <number>
#ifndef ATP_MAX_FREEQ_LENGTH
/* Maximum Number of Memory Blocks Kept in the Free Queue */
#define ATP_MAX_FREEQ_LENGTH 100
#endif

#define ATP_MAX_FREEQ_SIZE { $ATP_MAX_FREEQ_SIZE } <number>
#ifndef ATP_MAX_FREEQ_SIZE
/* Maximum Number of Bytes Kept Unfreed in the Free Queue */
#define ATP_MAX_FREEQ_SIZE 1000000
#endif

#define ATP_MAX_FREEQ_BLOCK_SIZE { $ATP_MAX_FREEQ_BLOCK_SIZE ? $ATP_MAX_FREEQ_BLOCK_SIZE : $ATP_MAX_FREEQ_SIZE } <number>
#ifndef ATP_MAX_FREEQ_BLOCK_SIZE
/* Maximum Number of Bytes Kept Unfreed in the Free Queue */
#define ATP_MAX_FREEQ_BLOCK_SIZE 1000000
#endif

#define ATP_REPORTS_ABWL { $ATP_REPORTS_ABWL } ATL_YES|ATL_NO
#ifndef ATP_REPORTS_ABWL
/* Late Detect Array Bounds Write Reporting */
#define ATP_REPORTS_ABWL ATL_YES
#endif

#define ATP_CHECK_SELECTED_BLOCKS { ($ATL_CHECK_FREQUENCY =~ /S/) } ATL_YES|ATL_NO
#ifndef ATP_CHECK_SELECTED_BLOCKS
/* allows ABWL and FMWL detection on selective list of memory blocks */
#define ATP_CHECK_SELECTED_BLOCKS ATL_NO
#endif

#define ATP_BREAK_ON_ERROR { $ATP_BREAK_ON_ERROR } ATL_YES|ATL_NO
#ifndef ATP_BREAK_ON_ERROR
/* allows breaking the code under debug when ATP errors are detected */
#define ATP_BREAK_ON_ERROR ATL_NO
#endif

#define ATP_RED_ZONE_SIZE { $ATP_RED_ZONE_SIZE } <number>
#ifndef ATP_RED_ZONE_SIZE
/* Size in Bytes of each of the two Red Zones
 * (one before and one after the Tracked Memory Block) */
#define ATP_RED_ZONE_SIZE 16
#endif

#define ATP_REPORTS_MIU { $ATP_REPORTS_MIU } ATL_YES|ATL_NO
#ifndef ATP_REPORTS_MIU
/* Memory In Use Reporting */
#define ATP_REPORTS_MIU ATL_NO
#endif

#define ATP_REPORTS_FUM { $ATP_REPORTS_FUM } ATL_YES|ATL_NO
#ifndef ATP_REPORTS_FUM
/* Free Unavailable Memory Reporting */
#define ATP_REPORTS_FUM ATL_NO
#endif

#define ATP_REPORTS_MLK { $ATP_REPORTS_MLK } ATL_YES|ATL_NO
#ifndef ATP_REPORTS_MLK
/* Memory LeaK Reporting */
#define ATP_REPORTS_MLK ATL_YES
#endif

#define ATP_REPORTS_MPK { $ATP_REPORTS_MPK } ATL_YES|ATL_NO
#ifndef ATP_REPORTS_MPK
/* Potencial Memory LeaK Reporting */
#define ATP_REPORTS_MPK ATL_YES
#endif

#define ATP_REPORTS_MPKC { $ATP_REPORTS_MPKC } ATL_YES|ATL_NO
#ifndef ATP_REPORTS_MPKC
/* Child of Potencial Memory LeaK Reporting */
#define ATP_REPORTS_MPKC ATL_YES
#endif

#define ATP_REPORTS_PMLK { $ATP_REPORTS_PMLK } ATL_YES|ATL_NO
#ifndef ATP_REPORTS_PMLK
/* Memory Pure MLK Reporting */
#define ATP_REPORTS_PMLK ATL_NO
#endif

#define ATP_KEEP_CONTENT { $ATP_KEEP_CONTENT } ATL_YES|ATL_NO
#ifndef ATP_KEEP_CONTENT
/* Signal Handled Reporting */
#define ATP_KEEP_CONTENT ATL_NO
#endif

#define ATP_NO_TRACK_ALLOCS_BEFORE_INIT { $ATP_NO_TRACK_ALLOCS_BEFORE_INIT } ATL_YES|ATL_NO
#ifndef ATP_NO_TRACK_ALLOCS_BEFORE_INIT
/* Signal Handled Reporting */
#define ATP_NO_TRACK_ALLOCS_BEFORE_INIT ATL_NO
#endif

#define ATP_DUMP_BLOCK_ONLY_ONCE { $ATP_DUMP_BLOCK_ONLY_ONCE } ATL_YES|ATL_NO
#ifndef ATP_DUMP_BLOCK_ONLY_ONCE
/* dump MLK and MPK only once in multi-dump */
#define ATP_DUMP_BLOCK_ONLY_ONCE ATL_NO
#endif

#define ATP_DUMP_UNFREED_ONLY_WITH_STACK { $ATP_DUMP_UNFREED_ONLY_WITH_STACK } ATL_YES|ATL_NO
#ifndef ATP_DUMP_UNFREED_ONLY_WITH_STACK
/* dump MLK and MPK  and MIU only if the call stack is available */
#define ATP_DUMP_UNFREED_ONLY_WITH_STACK ATL_NO
#endif

#define ATP_STACK_SIZE_LEVEL { $ATP_STACK_SIZE_LEVEL } <number>
#ifndef ATP_STACK_SIZE_LEVEL
/* How Many Call Stack Items in max stack Description 0=disabled, -1=all */
#define ATP_STACK_SIZE_LEVEL 16
#endif

#define ATP_REPORTS_SIG { $ATP_REPORTS_SIG } ATL_YES|ATL_NO
#ifndef ATP_REPORTS_SIG
/* Signal Handled Reporting */
#define ATP_REPORTS_SIG ATL_NO
#endif

/*******************************************************************************
* TestRT Application profiling:
*******************************************************************************/
#define ATA_STACK_MULTIPLE { $ATA_STACK_MULTIPLE } ATL_YES|ATL_NO
#ifndef ATA_STACK_MULTIPLE
/* unique measure at the method return */
#define ATA_STACK_MULTIPLE ATL_NO
#endif

/*******************************************************************************
* TestRT QuantifyLT:
*******************************************************************************/

/* #define ATQ_COMPUTE_OVERHEAD { $ATQ_COMPUTE_OVERHEAD } ATL_YES|ATL_NO */
#ifndef ATQ_COMPUTE_OVERHEAD
/* Computes Overhead on Measures Due to Its Measurement */
#define ATQ_COMPUTE_OVERHEAD ATL_NO
#endif

#define ATQ_DUMP_DRIVER { $ATQ_DUMP_DRIVER } ATL_YES|ATL_NO
#ifndef ATQ_DUMP_DRIVER
/* Dump Driver use */
#define ATQ_DUMP_DRIVER ATL_NO
#endif

#define ATQ_COMPUTE_MINMAX { ($ATQ_COMPUTE_MINMAX > 0) || $ATQ_COMPUTE_WCET } ATL_YES|ATL_NO
#ifndef ATQ_COMPUTE_MINMAX
/* Dump Driver use */
#define ATQ_COMPUTE_MINMAX ATL_NO
#endif

#define ATQ_COMPUTE_WCET { ($ATQ_COMPUTE_MINMAX > 1) || $ATQ_COMPUTE_WCET } ATL_YES|ATL_NO
#ifndef ATQ_COMPUTE_WCET
/* Dump Driver use */
#define ATQ_COMPUTE_WCET ATL_NO
#endif
/*******************************************************************************
* Several products settings:
*******************************************************************************/

#define ATL_MULTI_THREADS { $ATL_MULTI_THREADS  } ATL_YES|ATL_NO
#ifndef ATL_MULTI_THREADS
/*! Multi-threaded Application */
#define ATL_MULTI_THREADS ATL_NO
#endif

#define ATL_MULTI_PROCESS { $ATL_MULTI_PROCESS  } ATL_YES|ATL_NO
#ifndef ATL_MULTI_PROCESS
/*! Multi-process Application */
#define ATL_MULTI_PROCESS ATL_NO
#endif

#define ATL_THREADS_MAX { $ATL_THREADS_MAX  } <number>
#ifndef ATL_THREADS_MAX
/*! Threads Table Size */
#define ATL_THREADS_MAX 64
#endif

#define ATL_BUFFER_SIZE { $ATL_BUFFER_SIZE  } <number>
#ifndef ATL_BUFFER_SIZE
/*! I/O Optimisation Buffer Size In Bytes */
#define ATL_BUFFER_SIZE 16384
#endif

@ATL@ ATL_NODE_NAME "<string>"
#ifndef ATL_NODE_NAME
/*! Application Node Name */
#define ATL_NODE_NAME "rootNode"
#endif

#define ATL_MIME_NAME { $MIME_NAME  } "<string>"
#ifndef ATL_MIME_NAME
/*! Unicode Mime Name (default to US english) */
#define ATL_MIME_NAME "ISO-8859-1"
#endif

@ATL@ ATL_TRACES_FILE "<string>"
#ifndef ATL_TRACES_FILE
/*! Traces File Name */
#define ATL_TRACES_FILE "atlout.spt"
#define ATL_TRACES_FILE_LEN 10
#endif

@ATL@ ATL_HOST_ADDRESS "<string>"
#ifndef ATL_HOST_ADDRESS
/*! Host IP */
#define ATL_HOST_ADDRESS "127.0.0.1"
#endif

@ATL@ ATL_HOST_ADDRESS_PORT <number>
#ifndef ATL_HOST_ADDRESS_PORT
/*! Host port */
#define ATL_HOST_ADDRESS_PORT 7777
#endif

#define ATL_OS_CLOCK 1
#define ATL_PROCESS_CLOCK 2
#define ATL_CLOCK_KIND { $ATL_CLOCK_KIND && "ATL_PROCESS_CLOCK" || "ATL_OS_CLOCK" }
#ifndef ATL_CLOCK_KIND
/*! Clock type : OS or process */
#define ATL_CLOCK_KIND ATL_OS_CLOCK
#endif

#define ATL_DUMP_ON_RETURNING { ($ATL_CHECK_FREQUENCY=~ /R/) && "_ATP_CHK" || " " }
#ifndef ATL_DUMP_ON_RETURNING
/* define ABWL & FMWL check frequency (on each function returning) mempro only */
#define ATL_DUMP_ON_RETURNING
#endif

#define ATL_DYN_TABLE { $DYNTABLES  } ATL_YES|ATL_NO
#ifndef ATL_DYN_TABLE
/* define if instrumentation table for ATC, ATQ ATP must be allocated in the Heap */
#define ATL_DYN_TABLE ATL_NO
#endif

#define ATL_OBJ 0 /* object file used at link */
#define ATL_DLL 1 /* dynamic libray */
#define ATL_LIB 2 /* static libray */

#define ATL_RUNTIME_FORMAT { ($ATL_RUNTIME_FORMAT eq "DLL") ? "ATL_DLL" : (($ATL_RUNTIME_FORMAT eq "LIB") ? "ATL_LIB" : "ATL_OBJ") }  ATL_OBJ|ATL_DLL|ATL_LIB
#ifndef ATL_RUNTIME_FORMAT
/* define check frequency (on each function returning) */
#define ATL_RUNTIME_FORMAT ATL_OBJ
#endif

#define ATL_USE_VOLATIL_DLL { ($USE_UNLOAD_DLL ne "") && ($USE_UNLOAD_DLL ne "NONE") }  ATL_YES|ATL_NO
#ifndef ATL_USE_VOLATIL_DLL
/*! Multi-process Application */
#define ATL_USE_VOLATIL_DLL ATL_NO
#endif

#define ATL_CHECK_STACK { $ATL_CHECK_STACK  } ATL_YES|ATL_NO
#ifndef ATL_CHECK_STACK
/*! Multi-process Application */
#define ATL_CHECK_STACK ATL_NO
#endif

/* give the signal number that execute the result dump or 1 for default (SIGUSR1). 0 disable this functionality */
#define ATL_SIGNAL_DUMP { $ATL_SIGNAL_DUMP+($ATL_SIGNAL_STRATEGY*256)  } <number>
#ifndef ATL_SIGNAL_DUMP
/*! Dump on signal */
#define ATL_SIGNAL_DUMP ATL_NO
#endif  /* ATL_SIGNAL_DUMP */

#define ATL_OBSTOOLS_DUMP_FREQ { $ATL_OBSTOOLS_DUMP_FREQ  } <number>
#ifndef ATL_OBSTOOLS_DUMP_FREQ
/*! declare the number of DUMP requests should be made to dump results */
#define ATL_OBSTOOLS_DUMP_FREQ 0
#endif  /* ATL_SIGNAL_DUMP */

/*******************************************************************************
* TestRT Monitoring:
*******************************************************************************/
#define MNT_IO { $MNT_IO } 
/* NONE 0=use of atl_buffer and TDP mechanism, 1=use STD|FILE,  8=SOCKET connection, 3=external usr code */
#ifndef MNT_IO
#define MNT_IO 0
#endif  /* MNT_IO */

#define MNT_CYCLIC_ALLOWED { $MNT_CYCLIC_ALLOWED  } ATL_YES|ATL_NO
#ifndef MNT_CYCLIC_ALLOWED
#define MNT_CYCLIC_ALLOWED ATL_YES
#endif

#define MNT_FREQUENCY { $MNT_FREQUENCY  } <number>
#ifndef MNT_FREQUENCY
#define MNT_FREQUENCY 10
#endif

#define MNT_BITFIELDSUPPORT { $MNT_BITF  } <number>
#ifndef MNT_BITFIELDSUPPORT
#define MNT_BITFIELDSUPPORT 0 /* 0=NONE, 1=ReadOnly, 2=ReadWrite */
#endif


#define MNT_BIT_ORDER { $MNT_BIT_ORDER  } <number>
#ifndef MNT_BIT_ORDER
#define MNT_BIT_ORDER 0 /* 0=default, 1=Little, 2=Big Endian */
#endif

/*******************************************************************************
* Some TDP settings:
*******************************************************************************/

/* TDP $Ini{RUNTIME_DEFINES}  do not remove this line to insert basic specific setting */
/* TDP $ENV{RUNTIME_DEFINES}  do not remove this line to insert Environment specific setting*/

#endif
